using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Sample_VolaSmsPlus
{
    public partial class frmSender : Form
    {
        public frmSender()
        {
            InitializeComponent();
        }

        private void lnkVola_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage);
        }

        private void lnkSupporto_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport);
        }

        private void lnkLicenza_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                //Apre una shell del blocco di testo con la licenza
                string sPathUpdate = Application.StartupPath + "\\..\\..\\Licenza\\gplv3-it-final.pdf";

                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.EnableRaisingEvents = false;
                proc.StartInfo.FileName = sPathUpdate;
                proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
                proc.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void cmdAutentica_Click(object sender, EventArgs e)
        {
           try{

            if (txtPincode.Text.Length == 0)
                {
                    MessageBox.Show("Inserire il codice PINCODE e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //autentico il mittente
               if (Volasms.AuthenticateSender(txtAutenticare.Text,txtPincode.Text))
               {
                    AggiornaListaMittenti();
                    txtAutenticare.Text = "";
                    txtPincode.Text = "";
                    MessageBox.Show("Mittente autenticato e pronto per essere utilizzato nell'invio di SMS.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }else
                {
                    AggiornaListaMittenti();
                    MessageBox.Show("Errore durante l'auteticazione del mittente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
                
        }

        private void cmdAggiungi_Click(object sender, EventArgs e)
        {
            try
            {
                if (txtAggiungi.Text.Length == 0)
                {
                    MessageBox.Show("Inserire il mittente da aggiungere alla lista e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Verifico il tipo del mittente
                string NuovoMittente = txtAggiungi.Text;
                NuovoMittente = Vola.VolaSmsPlus.VolaCheckGsm.CheckGSMNumber(NuovoMittente, Vola.VolaSmsPlus.VolaCheckGsm.FormatGsm.PLUS_COUNTRY_MSDN);
                if(NuovoMittente.Length ==0){
                   //Mittente alfanumerico
                    if (Volasms.AddSender(txtAggiungi.Text))
                    {
                        AggiornaListaMittenti();
                        txtAggiungi.Text = "";
                        MessageBox.Show("Mittente aggiunto correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    else
                    {
                        AggiornaListaMittenti();
                        MessageBox.Show("Errore durante l'inserimento del mittente alla lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }else{
                    //Mittente numerico
                    int risposta = Volasms.AddSenderGsm(txtAggiungi.Text);
                    AggiornaListaMittenti();
                    switch (risposta)
                    {
                        case -1:
                            MessageBox.Show("Errore durante l'inserimento del mittente alla lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            break;
                        case 0:
                            txtAggiungi.Text = "";
                            MessageBox.Show("Al numero mittente  stato inviato un SMS con un codice PINCODE utile per autenticare l'inserimento dello stesso all'interno della lista.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            break;
                        case 1:
                            MessageBox.Show("Mittente aggiunto correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            break;
                    }
                }

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                    
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }        

        private void cmdRimuovi_Click(object sender, EventArgs e)
        {
            try
            {
                if (cmbMittente.Text.Length == 0)
                {
                    MessageBox.Show("Selezionare il mittente da rimuovere dalla lista e riprovare", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                //Rimuovo il mittente
                if (Volasms.RemoveSender(cmbMittente.Text))
                {
                    AggiornaListaMittenti();
                    MessageBox.Show("Mittente rimosso correttamente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    AggiornaListaMittenti();
                    MessageBox.Show("Errore durante la rimozione del mittente.", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void CmdUpdate_Click(object sender, EventArgs e)
        {
            AggiornaListaMittenti();
        }

        private void AggiornaListaMittenti()
        {
            try
            {
                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;
                
                //Leggo la lista dei mittenti
                if (!Volasms.GetListSender())
                    MessageBox.Show("Errore nella ricezione della lista mittenti Vola\r\n\r\n", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);

                //Aggiorno i controlli con i dati
                cmbMittente.Items.Clear();
                txtAutenticare.Text = "";
                IEnumerator TEnumerator = Volasms.ListSender.GetEnumerator();
                Vola.VolaSmsPlus.VolaSender Mittente;
                for (int iCount = 1; iCount <= Volasms.ListSender.Count; iCount++)
                {
                    TEnumerator.MoveNext();

                    Mittente = (Vola.VolaSmsPlus.VolaSender)TEnumerator.Current;
                    cmbMittente.Items.Add(Mittente.mittente);                   
                    if (Mittente.type == Vola.VolaSmsPlus.VolaTypeSender.PREDEFINITO)
                        txtPredefinito.Text = Mittente.mittente;
                    else
                        cmbMittente.Text = Mittente.mittente;

                    if (Mittente.type == Vola.VolaSmsPlus.VolaTypeSender.DA_AUTENTICARE)
                    {
                        txtAutenticare.Text = Mittente.mittente;
                    }                        
                }

                if (txtAutenticare.Text.Length==0)
                {                    
                    cmdAutentica.Enabled = false;
                    txtAutenticare.Enabled = false;
                    
                }
                else
                {
                    txtPincode.Enabled = true;
                    cmdAutentica.Enabled = true;
                }
                
            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        
    }
}