using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Vola.VolaSmsPlus;

namespace Sample_VolaSmsPlus
{
    public partial class frmStatusSMS : Form
    {
        public frmStatusSMS()
        {
            InitializeComponent();
        }

        private void lnkVola_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkHomePage);
        }

        private void lnkSupporto_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            //Apre una shell del browser con il sito di Vola
            System.Diagnostics.Process.Start(Vola.VolaSmsPlus.VolaConstant.LinkSupport);
        }

        private void lnkLicenza_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            try
            {
                //Apre una shell del blocco di testo con la licenza
                string sPathUpdate = Application.StartupPath + "\\..\\..\\Licenza\\gplv3-it-final.pdf";

                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.EnableRaisingEvents = false;
                proc.StartInfo.FileName = sPathUpdate;
                proc.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Maximized;
                proc.Start();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cmdClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void cmdStatus_Click(object sender, EventArgs e)
        {
            try
            {
                string sMessage;
                if (txtOrderid.Text.Length == 0)
                {
                    MessageBox.Show("Inserire codice orderid di cui verificare lo stato di notifica", "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return;
                }

                Vola.VolaSmsPlus.VolaSmsPlus Volasms = new Vola.VolaSmsPlus.VolaSmsPlus();

                //Inizializzo il componente con le propriet di autenticazione
                Volasms.UserName = txtUsername.Text;
                Volasms.Password = txtPassword.Text;
                Volasms.VapCode = "";

                //Inizializzo il componente con le propriet di connessione
                Volasms.AutomaticProxy = true;
                Volasms.EncryptSSL = true;

                Volasms.ClearMessageToNotify();

                //Aggiungo il messaggio alla lista, se il destinatario non  specficato
                //leggo lo stato di tutti i destinatari nel gruppo di invio
                Vola.VolaSmsPlus.VolaMessaggio Messaggio = Volasms.AddMessageToNotify(txtOrderid.Text, txtMsdn.Text);                   
                if (Messaggio == null)
                {
                    sMessage = "Orderid non inserito correttamente nella lista dei messaggi da verificare lo stato di notifica.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }              
                Vola.VolaSmsPlus.VolaMsdn Msdn = (Vola.VolaSmsPlus.VolaMsdn)Messaggio.listaDestinatari[0];
                if (Msdn.status != Vola.VolaSmsPlus.VolaMsdnStatus.MSDN_INLIST)
                {
                    sMessage = "Orderid non inserito correttamente nella lista dei messaggi da verificare lo stato di notifica.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //E' possibile aggiungere pi messaggi in modo che con una chimata ottenere pi informazioni possibili
                //Il numero massimo  1000

                //Prima di inviare controllo lo stato della lista
                if (Volasms.CountMessageToNotify() <= 0)
                {
                    sMessage = "Impossibile continuare con la ricezione delle notifiche perch non sono presenti messaggi corretti nella lista.";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //Invio il messaggio
                if (Volasms.GetStatusNotify() == false)
                {
                    sMessage = "Errore durante la ricezione delle notifiche";
                    MessageBox.Show(sMessage, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                IEnumerator Lista = Volasms.MessageListToNotify.GetEnumerator();
                IEnumerator ListaMsdn; 
                ListViewItem listItem;
                VolaMessaggio NuovoMessaggio;
                VolaMsdn NuovoMsdn;
                lstStatus.Items.Clear();

                //Aggiorno i controlli
                while (Lista.MoveNext())
                {
                    NuovoMessaggio = (VolaMessaggio)Lista.Current;
                    
                    ListaMsdn = NuovoMessaggio.listaDestinatari.GetEnumerator();
                    while (ListaMsdn.MoveNext())
                    {
                        listItem = lstStatus.Items.Add(NuovoMessaggio.orderid[0]);
                        NuovoMsdn= (VolaMsdn)ListaMsdn.Current;
                        listItem.SubItems.Add(NuovoMsdn.gsm);
                        listItem.SubItems.Add(NuovoMsdn.datatimestatus);
                        listItem.SubItems.Add(NuovoMsdn.status.ToString());
                        listItem.SubItems.Add(NuovoMsdn.reasoncode.ToString());
                    }

                }
               

            }
            catch (Vola.VolaSmsPlus.VolaException ex)
            {
                MessageBox.Show("Errore libreria Vola: " + ex.Codice + "\r\n\r\n" + ex.Messaggio, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Sample VolaSmsPlus", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

    }
}